<?php
/*
    Copyright (C) 2007 Yan Morin <yan.morin@gmail.com>

    This file is part of libfdpf.

    libfdpf is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    libfdpf is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with libfdpf.  If not, see <http://www.gnu.org/licenses/>.
*/
require_once dirname(__FILE__).'/fdpf_iwriter.php';
class FDPF_FPDFWriter extends FDPF_IWriter {
	var $varName = 'pdf';
	var $lastfontline = '';
	var $lastfillcolor = '';
	var $lastdrawcolor = '';
	function FDPF_FPDFWriter() {}
	function _header() {
		echo '<' . '?php'."\nrequire_once('fpdf/fpdf.php')".EOL;
		$format = ($this->pagewidth==0 && $this->pageheight==0) ?
			'\''.$this->format.'\'' : 
			'new Array('.$this->pagewidth.','.$this->pageheight.')';
		echo $this->_on(0).' = new FPDF(\''.$this->orientation.'\', \''.$this->unit.'\', '.$format.')'.EOL;
	}
	function _footer() {
		// end
		echo $this->_on().'Output();'."\n?" . ">\n";
	}
	function page_start($pageOrientation, $pagewidth, $pageheight) {
		echo $this->_on().'AddPage(\''.$pageOrientation.'\')'.EOL;
		if ($pw != '' && $ph != '') {
			echo '//'.$this->_on()."SetPageSize($pw,$ph)".EOL;
		}
	}
	function page_end() {
		echo "\n";
	}
	function text($x, $y, $txt) { 
		echo $this->_on().'Text('.$x.','.$y.',\''.addslashes($txt).'\')'.EOL;
	}
	function line($x1,$y1,$x2,$y2) {
		echo $this->_on()."Line($x1,$y1,$x2,$y2)".EOL;
	}
	function linewidth($width) {
		echo $this->_on().'SetLineWidth('.$width.')'.EOL;
	}
	function rect($x,$y,$w,$h,$pdfstyle) {
		$style = '';
		switch($pdfstyle) {
			case 'B': 
			case 'h': $style = 'DF'; break;

			case 'S': $style = 'D'; break; // Stroke

			case 'f': 
			case 'f*': $style = 'F'; break; // fill
		}
		echo $this->_on()."Rect($x,$y,$w,$h,'$style')".EOL;
	}
	function font($family, $type, $size) {
		$fontline = $this->_on().'SetFont(\''.$family.'\',\''.$type.'\','.$size.')'.EOL;
		if ($fontline != $this->lastfontline) {
			echo $fontline;
		}
	}
	function fillcolor($r,$g,$b) {
		$fillcolor = $this->_on().'SetFillColor('.$r.','.$g.','.$b.')'.EOL;
		if ($fillcolor != $this->lastfillcolor) {
			echo $fillcolor;
		}
	}
	function drawcolor($r,$g,$b) {
		$drawcolor = $this->_on().'SetDrawColor('.$r.','.$g.','.$b.')'.EOL;
		if ($drawcolor != $this->lastfillcolor) {
			echo $drawcolor;
		}
	}
	function image($id,$x,$y,$w,$h) {
		echo '//'.$this->_on()."Image('image{$id}.png',$x, $y, $w, $h, 'PNG')".EOL;
	}

	// output name ($doc)
	function _on($p = 1) {
		$strp = ($p) ? '->' : '';
		return '$' .$this->varName . $strp;
	}

}

?>
